'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

exports.filterUrl = filterUrl;
exports.urlCache = urlCache;
exports.logger = logger;
exports.body2cheerio = body2cheerio;

var _cheerio = require('cheerio');

var _cheerio2 = _interopRequireDefault(_cheerio);

var _validUrl = require('valid-url');

var _validUrl2 = _interopRequireDefault(_validUrl);

var _exceptions = require('./exceptions');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * filter only valid url
 *
 * @sideeffect: throw CancelRequest error
 */
function filterUrl(options) {
  if (!_validUrl2.default.isWebUri(options.uri)) {
    throw new _exceptions.CancelRequest();
  }

  return options;
}

/**
 * simple in memory cache middleware
 *
 * @sideeffect: throw CancelRequest error
 */
function urlCache() {
  var simpleCache = {};

  return function (options) {
    if (simpleCache[options.uri]) {
      throw new _exceptions.CancelRequest();
    }

    simpleCache[options.uri] = true;
    return options;
  };
}

/**
 * logger middleware
 *
 * @sideeffect: console.log arguments
 */
function logger() {
  for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
    args[_key] = arguments[_key];
  }

  var a = args;
  if (a.length === 1) a = a[0];
  // eslint-disable-next-line no-console
  console.log('@arguments:', a);
  return a;
}

/**
 * body2cheerio middleware
 *
 * @sideeffect: [response, body] was mutated into [response, $]
 * `$` is cheerio object
 */
function body2cheerio(_ref) {
  var _ref2 = _slicedToArray(_ref, 3);

  var response = _ref2[0];
  var body = _ref2[1];
  var options = _ref2[2];

  if (!body) return [response, body];

  return [response, _cheerio2.default.load(body), options];
}