'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _eventemitter = require('eventemitter3');

var _eventemitter2 = _interopRequireDefault(_eventemitter);

var _taskQueue = require('./task-queue');

var _taskQueue2 = _interopRequireDefault(_taskQueue);

var _request = require('./request');

var _request2 = _interopRequireDefault(_request);

var _exceptions = require('./exceptions');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { return step("next", value); }, function (err) { return step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var defaultOptions = {
  concurrency: 1,
  prerequest: [],
  requestCache: function requestCache() {},

  preprocess: [],
  processor: Promise.resolve
};

function reduceMiddlewares(middlewares, args) {
  return middlewares.reduce(function (p, mw) {
    return p.then(mw);
  }, Promise.resolve(args));
}

var StackableCrawler = function (_EventEmitter) {
  _inherits(StackableCrawler, _EventEmitter);

  function StackableCrawler() {
    var options = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

    _classCallCheck(this, StackableCrawler);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(StackableCrawler).call(this));

    _this._options = Object.assign({}, defaultOptions, options);
    _this._queue = new _taskQueue2.default(_this._options.concurrency);
    _this._queue.on('stopped', function () {
      return _this.emit('stopped');
    });
    _this._queue.on('empty', function () {
      return _this.emit('done');
    });
    return _this;
  }

  _createClass(StackableCrawler, [{
    key: 'add',
    value: function add(url) {
      this._queue.enqueue(this._createAsyncTask(url));
    }
  }, {
    key: 'stop',
    value: function stop() {
      this._queue.stop();
    }
  }, {
    key: 'start',
    value: function start() {
      this._queue.start();
    }
  }, {
    key: 'applyMiddlewarePrerequest',
    value: function () {
      var _ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee(url) {
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return reduceMiddlewares(this._options.prerequest, { uri: url });

              case 2:
                return _context.abrupt('return', _context.sent);

              case 3:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function applyMiddlewarePrerequest(_x2) {
        return _ref.apply(this, arguments);
      }

      return applyMiddlewarePrerequest;
    }()
  }, {
    key: '_createAsyncTask',
    value: function _createAsyncTask(url) {
      var _this2 = this;

      return _asyncToGenerator(regeneratorRuntime.mark(function _callee2() {
        var requestOptions, cached, results, mwResults;
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.prev = 0;
                _context2.next = 3;
                return _this2.applyMiddlewarePrerequest(url);

              case 3:
                requestOptions = _context2.sent;
                _context2.next = 6;
                return _this2._options.requestCache(requestOptions);

              case 6:
                cached = _context2.sent;

                if (!cached) {
                  _context2.next = 11;
                  break;
                }

                _context2.t0 = cached;
                _context2.next = 14;
                break;

              case 11:
                _context2.next = 13;
                return (0, _request2.default)(requestOptions);

              case 13:
                _context2.t0 = _context2.sent;

              case 14:
                results = _context2.t0;
                _context2.next = 17;
                return reduceMiddlewares(_this2._options.preprocess, results);

              case 17:
                mwResults = _context2.sent;
                _context2.next = 20;
                return _this2._options.processor(mwResults);

              case 20:
                _context2.next = 27;
                break;

              case 22:
                _context2.prev = 22;
                _context2.t1 = _context2['catch'](0);

                if (!(_context2.t1 instanceof _exceptions.CancelRequest)) {
                  _context2.next = 26;
                  break;
                }

                return _context2.abrupt('return');

              case 26:

                _this2.emit('error', _context2.t1, url);

              case 27:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, _this2, [[0, 22]]);
      }));
    }
  }]);

  return StackableCrawler;
}(_eventemitter2.default);

exports.default = StackableCrawler;