'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _eventemitter = require('eventemitter3');

var _eventemitter2 = _interopRequireDefault(_eventemitter);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { return step("next", value); }, function (err) { return step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TaskQueue = function (_EventEmitter) {
  _inherits(TaskQueue, _EventEmitter);

  function TaskQueue() {
    var concurrency = arguments.length <= 0 || arguments[0] === undefined ? 1 : arguments[0];

    _classCallCheck(this, TaskQueue);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(TaskQueue).call(this));

    _this.q = [];
    _this.concurrency = concurrency;
    _this.running = true;

    _this._runningTaskCount = 0;
    return _this;
  }

  _createClass(TaskQueue, [{
    key: 'enqueue',
    value: function enqueue(task) {
      this.q.push(task);

      this._dequeue();
    }
  }, {
    key: 'start',
    value: function start() {
      this.running = true;

      this._dequeue();
    }
  }, {
    key: 'stop',
    value: function stop() {
      this.running = false;
    }
  }, {
    key: '_dequeue',
    value: function () {
      var _ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee() {
        var _this2 = this;

        var task;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (!(this._runningTaskCount === this.concurrency)) {
                  _context.next = 2;
                  break;
                }

                return _context.abrupt('return');

              case 2:
                if (this.running) {
                  _context.next = 4;
                  break;
                }

                return _context.abrupt('return');

              case 4:
                if (!(this.q.length === 0)) {
                  _context.next = 6;
                  break;
                }

                return _context.abrupt('return');

              case 6:
                task = this.q.shift();


                this._runningTaskCount++;

                if (this._runningTaskCount < this.concurrency) this._dequeue();

                _context.next = 11;
                return task().then(function () {
                  return _this2._postDequeue();
                }).catch(function (e) {
                  _this2._postDequeue();
                  _this2.emit('error', e);
                });

              case 11:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function _dequeue() {
        return _ref.apply(this, arguments);
      }

      return _dequeue;
    }()
  }, {
    key: '_postDequeue',
    value: function _postDequeue() {
      this._runningTaskCount--;
      if (this._runningTaskCount < this.concurrency) this._dequeue();
      if (this._runningTaskCount === 0 && this.running === false) this.emit('stopped');
      if (this.q.length === 0) this.emit('empty');
    }
  }]);

  return TaskQueue;
}(_eventemitter2.default);

exports.default = TaskQueue;